package gui_design_and_implimentation;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.Vector;

public class Main extends JApplet {
  BorderLayout borderLayout1 = new BorderLayout();
  JTabbedPane tabbedPane = new JTabbedPane();
  JPanel MemberInformation = new JPanel();
  JPanel AvailableLoanBooks = new JPanel();
  JPanel StaffInformation = new JPanel();
  JButton btnPrintBook = new JButton();
  JButton btnBorrow = new JButton();
  JButton btnPrintMember = new JButton();
  PnlAddLibraryBooks pnlAddLibraryBooks = new PnlAddLibraryBooks(this);
  PnlLibraryBooks pnlLibraryBooks = new PnlLibraryBooks(this);
  PnlMemberBooks pnlMemberBooks = new PnlMemberBooks(this);
  PnlMember pnlMember = new PnlMember(this);
  PnlSelectMember pnlSelectMember = new PnlSelectMember(this);

  public Main() {}

  public void init() {
    jbInit();
  }

  private void jbInit() {
    this.setSize(new Dimension(640, 480));
    this.getContentPane().setLayout(borderLayout1);
    this.getContentPane().setLayout(new BorderLayout());
    this.getContentPane().add(tabbedPane, BorderLayout.CENTER);
//Members Information Tab
    MemberInformation.setLayout(null);
    pnlMember.setBounds(new Rectangle(0, 0, 635, 300));
    pnlMemberBooks.setBounds(new Rectangle(0, 300, 635, 150));
//Available Loan Books Tab
    AvailableLoanBooks.setLayout(null);
    pnlSelectMember.setBounds(new Rectangle(0, 0, 635, 200));
    pnlLibraryBooks.setBounds(new Rectangle(0, 230, 635, 200));
    btnPrintBook.setText("Print Current Book");
    btnPrintBook.setBounds(new Rectangle(0, 431, 165, 23));
    btnPrintBook.addActionListener(new Main_btnPrintBook_actionAdapter(this));
    btnPrintMember.setText("Print Current Member");
    btnPrintMember.setBounds(new Rectangle(165, 431, 165, 23));
    btnPrintMember.addActionListener(new Main_btnPrintMember_actionAdapter(this));
    btnBorrow.setText("Borrow Book (Not Working)");
    btnBorrow.setBounds(new Rectangle(330, 431, 165, 23));
    btnBorrow.addActionListener(new Main_btnBorrow_actionAdapter(this));
//Staff Information Tab
    StaffInformation.setLayout(null);
    pnlAddLibraryBooks.setBounds(new Rectangle(0, 0, 635, 400));

//Members Information Tab
    tabbedPane.add(MemberInformation, "Members Information");
    MemberInformation.add(pnlMember, null);
    MemberInformation.add(pnlMemberBooks, null);
//Available Loan Books Tab
    tabbedPane.add(AvailableLoanBooks, "Library Books");
    AvailableLoanBooks.add(pnlSelectMember, null);
    AvailableLoanBooks.add(btnPrintBook, null);
    AvailableLoanBooks.add(btnPrintMember, null);
    AvailableLoanBooks.add(btnBorrow, null);
    AvailableLoanBooks.add(pnlLibraryBooks, null);
//Staff Information Tab
    tabbedPane.add(StaffInformation, "Staff Managment");
    StaffInformation.add(pnlAddLibraryBooks, null);
  }






  public void addBook(Book book){
    pnlAddLibraryBooks.addBook(book);
    pnlLibraryBooks.addBook(book);
  }

  public void addMember(Member member){
    pnlMember.addMember(member);
    pnlSelectMember.addMember(member);
  }

  void btnPrintBook_actionPerformed(ActionEvent e) {
    Vector aBook = new Vector();
    aBook = pnlLibraryBooks.getBook();
    System.out.println(aBook);
  }

  void btnBorrow_actionPerformed(ActionEvent e) {
    Vector aBook = new Vector();
    aBook = pnlLibraryBooks.getBook();
    pnlSelectMember.getMember().add(aBook);
    Vector aMember = new Vector();
    aMember = pnlSelectMember.getMember();
    System.out.println(aMember);
  }

  void btnPrintMember_actionPerformed(ActionEvent e) {
    Vector aMember = new Vector();
    aMember = pnlSelectMember.getMember();
    System.out.println(aMember);

  }
}

class Main_btnPrintBook_actionAdapter implements java.awt.event.ActionListener {
  Main adaptee;

  Main_btnPrintBook_actionAdapter(Main adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btnPrintBook_actionPerformed(e);
  }
}

class Main_btnBorrow_actionAdapter implements java.awt.event.ActionListener {
  Main adaptee;

  Main_btnBorrow_actionAdapter(Main adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btnBorrow_actionPerformed(e);
  }
}

class Main_btnPrintMember_actionAdapter implements java.awt.event.ActionListener {
  Main adaptee;

  Main_btnPrintMember_actionAdapter(Main adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btnPrintMember_actionPerformed(e);
  }
}
