package gui_design_and_implimentation;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.Vector;
import javax.swing.table.DefaultTableModel;

public class PnlAddLibraryBooks extends JPanel {

  LibraryBooks library = new LibraryBooks();
  AddBooksFrame addBooksFrame;
  DefaultTableModel model;
  JScrollPane scrLibrary = new JScrollPane();
  JTable bookTable = new JTable();

  Vector columns = new Vector();
  Vector data = new Vector();
  Vector addBooks = new Vector();

  Main main;
  GridLayout AddBookLayout = new GridLayout();

  JPanel pnlSouth = new JPanel();
  JButton btnAddBook = new JButton("Add Book");
  JButton btnReturn = new JButton("Remove Book");
  JButton btnRefresh = new JButton("Refresh");

  void jbInit() throws Exception {
    this.setLayout(null);

    pnlSouth.setLayout(null);

    btnReturn.setBounds(new Rectangle(137, 8, 118, 23));
    btnReturn.setEnabled(false);

    btnAddBook.setBounds(new Rectangle(18, 8, 118, 23));
    btnAddBook.setEnabled(true);
    btnAddBook.setFocusPainted(true);
    btnAddBook.setMnemonic('0');
    btnAddBook.addActionListener(new PnlAddLibraryBooks_btnAddBook_actionAdapter(this));

    btnRefresh.setBounds(new Rectangle(256, 8, 118, 23));
    btnRefresh.setEnabled(false);
    btnRefresh.addActionListener(new PnlAddLibraryBooks_btnRefresh_actionAdapter(this));

    pnlSouth.setBounds(new Rectangle(124, 363, 393, 33));
    scrLibrary.setBounds(new Rectangle(1, 1, 639, 360));
    pnlSouth.add(btnReturn);
    pnlSouth.add(btnAddBook, null);
    pnlSouth.add(btnRefresh);
    this.add(scrLibrary, null);
    this.add(pnlSouth, null);
    scrLibrary.getViewport().add(bookTable, null);

    setColumns();
  }

  public PnlAddLibraryBooks(Main main) {
    this.main=main;
    try {
      jbInit();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  void btnAddBook_actionPerformed(ActionEvent e) {
    addBooksFrame = new AddBooksFrame(main);
    addBooksFrame.setVisible(true);
    addBooksFrame.pack();
  }

  public void addBook(Book book){
    this.addBooks.add(book);
    this.library.getBook().setBook(addBooks);
    display();
  }

  private void setColumns(){
    columns.add("ISBN");
    columns.add("Publisher");
    columns.add("Author");
    columns.add("Title");
    columns.add("Amount");
  }

  void btnRefresh_actionPerformed(ActionEvent e) {
    display();
  }

  private void display() {
    data = new Vector();
    addBooks = library.getBook().getBook();
    for (int i =0; i<addBooks.size(); i++) {
      Book libraryBooks = (Book) addBooks.get(i);
      Vector row = new Vector();
      row.add(libraryBooks.getISBN());
      row.add(libraryBooks.getPublisher());
      row.add(libraryBooks.getAuthor());
      row.add(libraryBooks.getTitle());
      row.add(new Double(libraryBooks.getAmount()));
      data.add(row);
      System.out.println("Testing Library Book Storage"+"\n"+libraryBooks);
    }
    model = new DefaultTableModel(data, columns);
    bookTable.setModel(model);
  }

}

class PnlAddLibraryBooks_btnRefresh_actionAdapter implements java.awt.event.ActionListener {
  PnlAddLibraryBooks adaptee;

  PnlAddLibraryBooks_btnRefresh_actionAdapter(PnlAddLibraryBooks adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btnRefresh_actionPerformed(e);
  }
}

class PnlAddLibraryBooks_btnAddBook_actionAdapter implements java.awt.event.ActionListener {
  PnlAddLibraryBooks adaptee;

  PnlAddLibraryBooks_btnAddBook_actionAdapter(PnlAddLibraryBooks adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btnAddBook_actionPerformed(e);
  }
}
