package gui_design_and_implimentation;

import java.awt.*;
import javax.swing.*;
import java.util.Vector;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableColumnModel;


public class PnlLibraryBooks extends JPanel {

  LibraryBooks library = new LibraryBooks();
  Main main;
  JScrollPane scrLibraryBook = new JScrollPane();
  JTable libraryBookTable = new JTable();
  DefaultTableModel model;
  BorderLayout LibraryBookLayout = new BorderLayout();

  Vector columns = new Vector();
  Vector data = new Vector();
  Vector books = new Vector();

  public PnlLibraryBooks(Main main) {
    this.main = main;
    try {
      jbInit();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  void jbInit() throws Exception {
    this.setLayout(LibraryBookLayout);
    this.add(scrLibraryBook, BorderLayout.CENTER);
    scrLibraryBook.getViewport().add(libraryBookTable, null);

    setColumns();
  }

  private void setColumns(){
    columns.add("ISBN");
    columns.add("Publisher");
    columns.add("Author");
    columns.add("Title");
    columns.add("Amount");
  }

  public void add(Book book) {
    addBook(book);
  }

  public void addBook(Book book){
    this.books.add(book);
    this.library.getBook().setBook(books);
    display();
  }

  private void display() {
    data = new Vector();
    books = library.getBook().getBook();
    for (int i =0; i<books.size(); i++) {
      Book libraryBooks = (Book) books.get(i);
      Vector row = new Vector();
      row.add(libraryBooks.getISBN());
      row.add(libraryBooks.getPublisher());
      row.add(libraryBooks.getAuthor());
      row.add(libraryBooks.getTitle());
      row.add(new Double(libraryBooks.getAmount()));
      data.add(row);
      System.out.println("Testing Library Book Storage"+"\n"+libraryBooks);
    }
    model = new DefaultTableModel(data, columns);
    libraryBookTable.setModel(model);
  }

  public Vector getBook() {
    int row = libraryBookTable.getSelectedRow();
    Vector selectedBook = new Vector();
    TableColumnModel colModel = libraryBookTable.getColumnModel();
    String isbn = (String)libraryBookTable.getValueAt(row, 0);
    String publisher = (String)libraryBookTable.getValueAt(row, 1);
    String author = (String)libraryBookTable.getValueAt(row, 2);
    String title = (String)libraryBookTable.getValueAt(row, 3);
    selectedBook.add(isbn);
    selectedBook.add(publisher);
    selectedBook.add(author);
    selectedBook.add(title);
    return selectedBook;
  }

}
