package gui_design_and_implimentation;

import java.awt.*;
import javax.swing.*;
import java.util.Vector;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableColumnModel;


public class PnlMemberBooks extends JPanel {

  Membership membership = new Membership();
  Main main;
  JScrollPane scrMemberBooks = new JScrollPane();
  JTable MemberTable = new JTable();
  DefaultTableModel model;
  BorderLayout MemberBookLayout = new BorderLayout();

  Vector columns = new Vector();
  Vector data = new Vector();
  Vector member = new Vector();

  public PnlMemberBooks(Main main) {
    this.main = main;
    try {
      jbInit();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  void jbInit() throws Exception {
    this.setLayout(MemberBookLayout);
    this.add(scrMemberBooks, BorderLayout.CENTER);
    scrMemberBooks.getViewport().add(MemberTable, null);

    setColumns();
  }

  private void setColumns(){
    columns.add("ISBN");
    columns.add("Publisher");
    columns.add("Author");
    columns.add("Title");
    columns.add("Amount");
  }

  public void add(Book book) {
    addBook(book);
  }

  public void addBook(Book book){
    this.member.add(book);
    this.membership.getMember().setBook(member);
    display();
  }

  private void display() {
    data = new Vector();
    member = membership.getMember().getBook();
    for (int i =0; i<member.size(); i++) {
      Book memberBooks = (Book) member.get(i);
      Vector row = new Vector();
      row.add(memberBooks.getISBN());
      row.add(memberBooks.getPublisher());
      row.add(memberBooks.getAuthor());
      row.add(memberBooks.getTitle());
      row.add(new Double(memberBooks.getAmount()));
      data.add(row);
      System.out.println("Testing Library Book Storage"+"\n"+memberBooks);
    }
    model = new DefaultTableModel(data, columns);
    MemberTable.setModel(model);
  }

  public Vector getBook() {
    int row = MemberTable.getSelectedRow();
    Vector selectedBook = new Vector();
    TableColumnModel colModel = MemberTable.getColumnModel();
    String isbn = (String)MemberTable.getValueAt(row, 0);
    String publisher = (String)MemberTable.getValueAt(row, 1);
    String author = (String)MemberTable.getValueAt(row, 2);
    String title = (String)MemberTable.getValueAt(row, 3);
    selectedBook.add(isbn);
    selectedBook.add(publisher);
    selectedBook.add(author);
    selectedBook.add(title);
    return selectedBook;
  }

}
