package gui_design_and_implimentation;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.Vector;
import javax.swing.table.DefaultTableModel;

public class PnlMember extends JPanel {

  JLabel lblMemberNo = new JLabel();
  JTextField txtMemberNo = new JTextField();
  JTextField txtFirstname = new JTextField();
  JLabel lblFirstname = new JLabel();
  JTextField txtSurname = new JTextField();
  JLabel lblSurname = new JLabel();
  JLabel lblTelephone = new JLabel();
  JTextField txtTelephone = new JTextField();
  JTextField txtStreet = new JTextField();
  JLabel lblStreet = new JLabel();
  JTextField txtCity = new JTextField();
  JLabel lblCity = new JLabel();
  JLabel lblHireDate = new JLabel();
  JTextField txtHireDate = new JTextField();
  JButton btnSearch = new JButton();
  JButton btnPrint = new JButton();
  JButton btnAdd = new JButton();
  Membership membership = new Membership();
  Vector addMember = new Vector();
  Vector currentMembers = new Vector();
  Vector columns = new Vector();
  Vector data = new Vector();
  Vector books = new Vector();
  Vector addBook = new Vector();
  Main main;
  JScrollPane jScrollPane1 = new JScrollPane();
  JTable MemberTable = new JTable();
  DefaultTableModel model;

  public PnlMember(Main main) {
    this.main = main;
    try {
      jbInit();
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }

  void jbInit() throws Exception {
    this.setLayout(null);
    lblFirstname.setText("Firstname");
    lblFirstname.setBounds(new Rectangle(0, 30, 151, 30));
    txtFirstname.setText("");
    txtFirstname.setBounds(new Rectangle(151, 30, 151, 30));
    lblSurname.setText("Surname");
    lblSurname.setBounds(new Rectangle(0, 60, 151, 30));
    txtSurname.setText("");
    txtSurname.setBounds(new Rectangle(151, 60, 151, 30));
    lblTelephone.setText("Telephone");
    lblTelephone.setBounds(new Rectangle(0, 90, 151, 30));
    txtTelephone.setText("");
    txtTelephone.setBounds(new Rectangle(151, 90, 151, 30));
    lblStreet.setText("Street");
    lblStreet.setBounds(new Rectangle(0, 120, 151, 30));
    txtStreet.setText("");
    txtStreet.setBounds(new Rectangle(151, 120, 151, 30));
    lblCity.setText("City");
    lblCity.setBounds(new Rectangle(0, 150, 151, 30));
    txtCity.setText("");
    txtCity.setBounds(new Rectangle(151, 150, 151, 30));
    lblHireDate.setToolTipText("");
    lblHireDate.setVerifyInputWhenFocusTarget(true);
    lblHireDate.setText("Hire Date");
    lblHireDate.setBounds(new Rectangle(0, 180, 151, 30));
    txtHireDate.setText("");
    txtHireDate.setBounds(new Rectangle(151, 180, 151, 30));
    lblMemberNo.setToolTipText("");
    lblMemberNo.setText("Staff Number");
    lblMemberNo.setBounds(new Rectangle(0, 0, 151, 30));
    txtMemberNo.setText("");
    txtMemberNo.setBounds(new Rectangle(151, 0, 151, 30));
    btnSearch.setBounds(new Rectangle(0, 240, 151, 30));
    btnSearch.setEnabled(false);
    btnSearch.setDoubleBuffered(true);
    btnSearch.setText("Search");
    btnPrint.setBounds(new Rectangle(151, 270, 151, 30));
    btnPrint.setEnabled(true);
    btnPrint.setRolloverEnabled(true);
    btnPrint.setSelected(false);
    btnPrint.setText("Print");
    btnPrint.setVerticalAlignment(javax.swing.SwingConstants.CENTER);
    btnPrint.addActionListener(new PnlMember_btnPrint_actionAdapter(this));
    btnAdd.setBounds(new Rectangle(151, 240, 151, 30));
    btnAdd.setText("Add");
    btnAdd.addActionListener(new PnlMember_btnAdd_actionAdapter(this));
    jScrollPane1.setBounds(new Rectangle(302, 1, 332, 299));
    this.add(lblMemberNo, null);
    this.add(txtMemberNo, null);
    this.add(lblFirstname, null);
    this.add(txtFirstname, null);
    this.add(lblSurname, null);
    this.add(txtSurname, null);
    this.add(lblTelephone, null);
    this.add(txtTelephone, null);
    this.add(lblStreet, null);
    this.add(txtStreet, null);
    this.add(lblCity, null);
    this.add(txtCity, null);
    this.add(lblHireDate, null);
    this.add(txtHireDate, null);
    this.add(btnSearch, null);
    this.add(btnAdd, null);
    this.add(btnPrint, null);
    this.add(jScrollPane1, null);
    jScrollPane1.getViewport().add(MemberTable, null);

    setColumns();
  }

  void btnAdd_actionPerformed(ActionEvent e) {
    try {
      create();
    }
    catch (Exception ex) {
      System.out.print("Error occured while creating Inventory");
    }
  }

  private void setColumns() {
    columns.add("Member Number");
    columns.add("Firstname");
    columns.add("Surname");
    columns.add("Telephone");
    columns.add("Street");
    columns.add("City");
    columns.add("Date Joined");
  }

  private void create() throws Exception {
    String aMemberNumber = this.txtMemberNo.getText();
    String aFirstname = this.txtFirstname.getText();
    String aSurname = this.txtSurname.getText();
    String aTelephone = this.txtTelephone.getText();
    String aStreet = this.txtStreet.getText();
    String aCity = this.txtCity.getText();
    String aHireDate = this.txtHireDate.getText();
    Member member = new Member(aMemberNumber, aFirstname, aSurname, aTelephone,aStreet, aCity, aHireDate);
    main.addMember(member);
  }

  public void add(Member member) {
    addMember(member);
  }

  public void addMember(Member member) {
    this.addMember.add(member);
    this.membership.getMember().setMember(addMember);
    display();
  }

  public void addBook(Book book) {
    this.addBook.add(book);
    this.membership.getMember().setBook(addBook);
    display();
  }


  private void display() {
    data = new Vector();
    books = membership.getMember().getMember();
    for (int i = 0; i < books.size(); i++) {
      Member currentMembers = (Member) books.get(i);
      Vector row = new Vector();
      row.add(currentMembers.getMemberNumber());
      row.add(currentMembers.getFirstname());
      row.add(currentMembers.getSurname());
      row.add(currentMembers.getTelephone());
      row.add(currentMembers.getStreet());
      row.add(currentMembers.getCity());
      row.add(currentMembers.getAmount());
      data.add(row);
      System.out.println("Testing Library Book Storage" + "\n" + currentMembers);
    }
    model = new DefaultTableModel(data, columns);
    MemberTable.setModel(model);
  }

  void btnPrint_actionPerformed(ActionEvent e) {
    currentMembers = membership.getMember().getMember();
    for (int i = 0; i < currentMembers.size(); i++) {
      Member aMember = (Member) currentMembers.get(i);
      System.out.println(aMember);
    }
  }
}

class PnlMember_btnAdd_actionAdapter
    implements java.awt.event.ActionListener {
  PnlMember adaptee;

  PnlMember_btnAdd_actionAdapter(PnlMember adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.btnAdd_actionPerformed(e);
  }
}

class PnlMember_btnPrint_actionAdapter implements java.awt.event.ActionListener {
  PnlMember adaptee;

  PnlMember_btnPrint_actionAdapter(PnlMember adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btnPrint_actionPerformed(e);
  }
}
