package gui_design_and_implimentation;

import java.awt.*;
import javax.swing.*;
import java.util.Vector;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableColumnModel;

public class PnlSelectMember extends JPanel {

  Membership membership = new Membership();
  Main main;
  JScrollPane scrSelectMember = new JScrollPane();
  JTable SelectMemberTable = new JTable();
  DefaultTableModel model;
  BorderLayout SelectMemberLayout = new BorderLayout();

  Vector addMember = new Vector();
  Vector columns = new Vector();
  Vector data = new Vector();
  Vector books = new Vector();

  public PnlSelectMember(Main main) {
    this.main = main;
    try {
      jbInit();
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }

  void jbInit() throws Exception {
    this.setLayout(SelectMemberLayout);
    this.add(scrSelectMember, BorderLayout.CENTER);
    scrSelectMember.getViewport().add(SelectMemberTable, null);

    setColumns();
  }

  private void setColumns() {
    columns.add("Member Number");
    columns.add("Firstname");
    columns.add("Surname");
    columns.add("Telephone");
    columns.add("Street");
    columns.add("City");
    columns.add("Date Joined");
  }


  public void add(Member member) {
    addMember(member);
  }

  public void addMember(Member member) {
    this.addMember.add(member);
    this.membership.getMember().setMember(addMember);
    display();
  }

  private void display() {
    data = new Vector();
    books = membership.getMember().getMember();
    for (int i =0; i<books.size(); i++) {
      Member currentMembers = (Member) books.get(i);
      Vector row = new Vector();
      row.add(currentMembers.getMemberNumber());
      row.add(currentMembers.getFirstname());
      row.add(currentMembers.getSurname());
      row.add(currentMembers.getTelephone());
      row.add(currentMembers.getStreet());
      row.add(currentMembers.getCity());
      row.add(currentMembers.getAmount());
      data.add(row);
      System.out.println("Testing Library Book Storage"+"\n"+currentMembers);
    }
    model = new DefaultTableModel(data, columns);
    SelectMemberTable.setModel(model);
  }

  public Vector getMember() {
    int row = SelectMemberTable.getSelectedRow();
    Vector selectedMember = new Vector();
    TableColumnModel colModel = SelectMemberTable.getColumnModel();
    String aMemberNumber = (String) SelectMemberTable.getValueAt(row, 0);
    String aFirstname = (String) SelectMemberTable.getValueAt(row, 1);
    String aSurname = (String) SelectMemberTable.getValueAt(row, 2);
    String aTelephone = (String) SelectMemberTable.getValueAt(row, 3);
    String aStreet = (String) SelectMemberTable.getValueAt(row, 4);
    String aCity = (String) SelectMemberTable.getValueAt(row, 5);
    String aAmount = (String) SelectMemberTable.getValueAt(row, 6);
    selectedMember.add(aMemberNumber);
    selectedMember.add(aFirstname);
    selectedMember.add(aSurname);
    selectedMember.add(aTelephone);
    selectedMember.add(aStreet);
    selectedMember.add(aCity);
    selectedMember.add(aAmount);
    return selectedMember;
  }

}
